/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ServiceListResponse type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ServiceListResponse{}

// ServiceListResponse struct for ServiceListResponse
type ServiceListResponse struct {
	Id           *int32  `json:"id,omitempty"`
	Service      *string `json:"service,omitempty"`
	Label        *string `json:"label,omitempty"`
	LastAction   *int32  `json:"last_action,omitempty"`
	Status       *bool   `json:"status,omitempty"`
	StatusDetail *string `json:"status_detail,omitempty"`
	CustomerId   *string `json:"customer_id,omitempty"`
	ServiceType  *string `json:"service_type,omitempty"`
}

// NewServiceListResponse instantiates a new ServiceListResponse object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewServiceListResponse() *ServiceListResponse {
	this := ServiceListResponse{}
	return &this
}

// NewServiceListResponseWithDefaults instantiates a new ServiceListResponse object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewServiceListResponseWithDefaults() *ServiceListResponse {
	this := ServiceListResponse{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise.
func (o *ServiceListResponse) GetId() int32 {
	if o == nil || IsNil(o.Id) {
		var ret int32
		return ret
	}
	return *o.Id
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetIdOk() (*int32, bool) {
	if o == nil || IsNil(o.Id) {
		return nil, false
	}
	return o.Id, true
}

// HasId returns a boolean if a field has been set.
func (o *ServiceListResponse) HasId() bool {
	if o != nil && !IsNil(o.Id) {
		return true
	}

	return false
}

// SetId gets a reference to the given int32 and assigns it to the Id field.
func (o *ServiceListResponse) SetId(v int32) {
	o.Id = &v
}

// GetService returns the Service field value if set, zero value otherwise.
func (o *ServiceListResponse) GetService() string {
	if o == nil || IsNil(o.Service) {
		var ret string
		return ret
	}
	return *o.Service
}

// GetServiceOk returns a tuple with the Service field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetServiceOk() (*string, bool) {
	if o == nil || IsNil(o.Service) {
		return nil, false
	}
	return o.Service, true
}

// HasService returns a boolean if a field has been set.
func (o *ServiceListResponse) HasService() bool {
	if o != nil && !IsNil(o.Service) {
		return true
	}

	return false
}

// SetService gets a reference to the given string and assigns it to the Service field.
func (o *ServiceListResponse) SetService(v string) {
	o.Service = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *ServiceListResponse) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *ServiceListResponse) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *ServiceListResponse) SetLabel(v string) {
	o.Label = &v
}

// GetLastAction returns the LastAction field value if set, zero value otherwise.
func (o *ServiceListResponse) GetLastAction() int32 {
	if o == nil || IsNil(o.LastAction) {
		var ret int32
		return ret
	}
	return *o.LastAction
}

// GetLastActionOk returns a tuple with the LastAction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetLastActionOk() (*int32, bool) {
	if o == nil || IsNil(o.LastAction) {
		return nil, false
	}
	return o.LastAction, true
}

// HasLastAction returns a boolean if a field has been set.
func (o *ServiceListResponse) HasLastAction() bool {
	if o != nil && !IsNil(o.LastAction) {
		return true
	}

	return false
}

// SetLastAction gets a reference to the given int32 and assigns it to the LastAction field.
func (o *ServiceListResponse) SetLastAction(v int32) {
	o.LastAction = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *ServiceListResponse) GetStatus() bool {
	if o == nil || IsNil(o.Status) {
		var ret bool
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetStatusOk() (*bool, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *ServiceListResponse) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given bool and assigns it to the Status field.
func (o *ServiceListResponse) SetStatus(v bool) {
	o.Status = &v
}

// GetStatusDetail returns the StatusDetail field value if set, zero value otherwise.
func (o *ServiceListResponse) GetStatusDetail() string {
	if o == nil || IsNil(o.StatusDetail) {
		var ret string
		return ret
	}
	return *o.StatusDetail
}

// GetStatusDetailOk returns a tuple with the StatusDetail field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetStatusDetailOk() (*string, bool) {
	if o == nil || IsNil(o.StatusDetail) {
		return nil, false
	}
	return o.StatusDetail, true
}

// HasStatusDetail returns a boolean if a field has been set.
func (o *ServiceListResponse) HasStatusDetail() bool {
	if o != nil && !IsNil(o.StatusDetail) {
		return true
	}

	return false
}

// SetStatusDetail gets a reference to the given string and assigns it to the StatusDetail field.
func (o *ServiceListResponse) SetStatusDetail(v string) {
	o.StatusDetail = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *ServiceListResponse) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *ServiceListResponse) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *ServiceListResponse) SetCustomerId(v string) {
	o.CustomerId = &v
}

// GetServiceType returns the ServiceType field value if set, zero value otherwise.
func (o *ServiceListResponse) GetServiceType() string {
	if o == nil || IsNil(o.ServiceType) {
		var ret string
		return ret
	}
	return *o.ServiceType
}

// GetServiceTypeOk returns a tuple with the ServiceType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ServiceListResponse) GetServiceTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ServiceType) {
		return nil, false
	}
	return o.ServiceType, true
}

// HasServiceType returns a boolean if a field has been set.
func (o *ServiceListResponse) HasServiceType() bool {
	if o != nil && !IsNil(o.ServiceType) {
		return true
	}

	return false
}

// SetServiceType gets a reference to the given string and assigns it to the ServiceType field.
func (o *ServiceListResponse) SetServiceType(v string) {
	o.ServiceType = &v
}

func (o ServiceListResponse) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ServiceListResponse) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Id) {
		toSerialize["id"] = o.Id
	}
	if !IsNil(o.Service) {
		toSerialize["service"] = o.Service
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.LastAction) {
		toSerialize["last_action"] = o.LastAction
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.StatusDetail) {
		toSerialize["status_detail"] = o.StatusDetail
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customer_id"] = o.CustomerId
	}
	if !IsNil(o.ServiceType) {
		toSerialize["service_type"] = o.ServiceType
	}
	return toSerialize, nil
}

type NullableServiceListResponse struct {
	value *ServiceListResponse
	isSet bool
}

func (v NullableServiceListResponse) Get() *ServiceListResponse {
	return v.value
}

func (v *NullableServiceListResponse) Set(val *ServiceListResponse) {
	v.value = val
	v.isSet = true
}

func (v NullableServiceListResponse) IsSet() bool {
	return v.isSet
}

func (v *NullableServiceListResponse) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableServiceListResponse(val *ServiceListResponse) *NullableServiceListResponse {
	return &NullableServiceListResponse{value: val, isSet: true}
}

func (v NullableServiceListResponse) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableServiceListResponse) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
